 #property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 CLR_NONE//Silver
#property indicator_width1 2
#property indicator_color2 CLR_NONE//Silver
#property indicator_width2 2
#property indicator_color3 Blue
#property indicator_width3 3
#property indicator_color4 Red
#property indicator_width4 3


extern int     Length         =  14;
extern int     Shuffle        =   3;
extern double  Deviation      =  10.0;

extern bool   AlertsOn        = true;
extern bool   AlertsOnCurrent = true;
extern bool   AlertsMessage   = true;
extern bool   AlertsSound     = true;
extern bool   AlertsEmail     = false;

extern bool   ShowText         = true;
extern int    TextPositionX    = 675;
extern int    TextPositionY    = 30;
extern color  upTextcolor      = Blue;
extern color  dnTextcolor      = Red;


int shift1 = 0;
int shift = 0;

//int Length;
double Bands[];
double Base_Signal[];
double Center_UP[];
double Center_DN[];
double Upper_Band[];
double Lower_Band[];
double trend[];

string TextDir = "4";

int TimeFrame;
string tf;
string Copyright = "";

//+-----------------------------------------------------------------------+

int init() {
   IndicatorBuffers(7);
  //SetIndexStyle(0, DRAW_HISTOGRAM); 
 //SetIndexShift(0, shift);
 //SetIndexStyle(1, DRAW_HISTOGRAM); 
 //SetIndexShift(1, shift);
   SetIndexStyle(2, DRAW_HISTOGRAM); 
   SetIndexShift(2, shift);
   SetIndexStyle(3, DRAW_HISTOGRAM); 
   SetIndexShift(3, shift);
   SetIndexStyle(4, DRAW_HISTOGRAM); 
   SetIndexShift(4, shift);
   SetIndexStyle(5, DRAW_HISTOGRAM); 
   SetIndexShift(5, shift);
   SetIndexBuffer(6,trend);
   
   
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   
   if (Length < 2) Length = 12;
   int i = Length - 1;
   string name = "GoldBands(";
   
   IndicatorShortName(name + Length + ")");
   SetIndexDrawBegin(0, i);
   SetIndexBuffer(0, Upper_Band);
   SetIndexDrawBegin(1, i);
   SetIndexBuffer(1, Lower_Band);
   SetIndexDrawBegin(2, i);
   SetIndexBuffer(2, Center_UP);
   SetIndexDrawBegin(3, i);
   SetIndexBuffer(3, Center_DN);
   SetIndexDrawBegin(4, i);
   SetIndexBuffer(4, Bands);
   SetIndexDrawBegin(5, i);
   SetIndexBuffer(5, Base_Signal);
 
/*         switch ( Period() )
         {
          case  5: Length =   Length;break;
          case 15: Length =   Length/3;break;
          case 30: Length =   Length*6;break;
          default: Length =   Length*12;break;
         }*/
   
     	switch(TimeFrame)
	{
		case 1:		tf=" M1";  break;
		case 5:		tf=" M5";  break;
		case 15:		tf=" M15"; break;
		case 30:		tf=" M30"; break;
		case 60:		tf=" H1";  break;
	   case 90:		tf=" M90";  break;
	   case 120:	tf=" H2";  break;
	   case 145:   tf=" M145"; break;
	   case 150:   tf=" M150"; break;
	   case 150:   tf=" M150"; break;
		case 165:   tf=" M165";  break;
	   case 180:	tf=" H3";  break;
	   case 240:	tf=" H4";  break;
	   case 270:	tf=" H4.5";  break;
	   case 300:	tf=" H5";  break;
	   case 330:	tf=" H5.5";  break;
	   case 360:	tf=" H6";  break;
	   case 390:	tf=" H6.5";  break;
	   case 420:	tf=" H7";  break;
	   case 480:	tf=" H8";  break;
		case 510:	tf=" 510m"; break;
		case 1440:	tf=" D1";  break;
		case 10080:	tf=" W1";  break;
		case 43200:	tf=" MN1"; break;
		default:	  {TimeFrame = Period(); init(); return(0);}
	
	
	}
   
   return (0);
   }

//+-----------------------------------------------------------------------+

   int deinit() {
   ObjectsDeleteAll(1,OBJ_LABEL);
   
   ObjectDelete(TextDir); 
   return (0);
   }

//+-----------------------------------------------------------------------+

   int start() {
   int x;
   double dev;
   double total;
   double signal;
   double sum2;
   
   Gold_Bands();
   sma();
   
   if (Bars <= Shuffle) return (0);
   int counted_bars = IndicatorCounted();
   for (int i = 1; i <= Shuffle; i++) {
      Base_Signal[Bars - i] = EMPTY_VALUE;
      Upper_Band[Bars - i] = EMPTY_VALUE;
      Lower_Band[Bars - i] = EMPTY_VALUE;
      Center_UP[Bars - i] = EMPTY_VALUE;
      Center_DN[Bars - i] = EMPTY_VALUE;
   }
   int limit = Bars - counted_bars;
   if (counted_bars > 0) limit++;
   i = Bars - Shuffle + 1;
   if (counted_bars > Shuffle - 1) i = Bars - counted_bars + 1;
   while (i >= 0) {
      total = 0.0;
      x = i + Shuffle - 1;
      signal = Base_Signal[i];
      while (x >= i) {
         sum2 = Bands[x] - signal;
         total += sum2 * sum2;
         x--;
      }
      dev = Deviation * MathSqrt(total / Shuffle);
      Upper_Band[i] = signal + dev;
      Lower_Band[i] = signal - dev;
      i--;
   }
   i = Bars - Shuffle + 1;
   if (counted_bars > Shuffle - 1) i = Bars - counted_bars + 1;
   while (i >= 0) 
   { 
         trend[i]     = trend[i+1];
         Center_DN[i] = EMPTY_VALUE;
         Center_UP[i] = EMPTY_VALUE;
         if (Base_Signal[i] < Bands[i]) { Center_UP[i] = Base_Signal[i]; trend[i] =  1; } 
         if (Base_Signal[i] > Bands[i]) { Center_DN[i] = Base_Signal[i]; trend[i] = -1; }
            if (trend[i]== 1) Commenter( 1);  
            if (trend[i]==-1) Commenter(-1); 
         i--;
   }
   manageAlerts();
   return (0);
}

//+-----------------------------------------------------------------------+

void Gold_Bands() {
   double close;
   double sum = 0.0;
   double Band2 = 0.0;
   int bars = 0;
   int limit3 = Bars - shift1 - 1;
   if (limit3 < Length) limit3 = Length;
   int j = 1;
   while (j <= Length) {
      close = Close[limit3];
      sum += close * j;
      Band2 += close;
      bars += j;
      j++;
      limit3--;
   }
   limit3++;
   j = limit3 + Length;
   while (limit3 >= 0) {
      Bands[limit3] = sum / bars;
      if (limit3 == 0) break;
      limit3--;
      j--;
      close = Close[limit3];
      sum = sum - Band2 + close * Length;
      Band2 -= Close[j];
      Band2 += close;
   }
   if (shift1 < 1) for (j = 1; j < Length; j++) Bands[Bars - j] = 0;
}

//+-----------------------------------------------------------------------+

void sma() {
   double sum = 0;
   int limit0 = Bars - shift1 - 1;
   if (limit0 < Shuffle) limit0 = Shuffle;
   int k = 1;
   while (k < Shuffle) {
      sum += Bands[limit0];
      k++;
      limit0--;
   }
   while (limit0 >= 0) {
      sum += Bands[limit0];
      Base_Signal[limit0] = sum / Shuffle;
      sum -= Bands[limit0 + Shuffle - 1];
      limit0--;
   }
   if (shift1 < 1) for (k = 1; k < Shuffle; k++) Base_Signal[Bars - k] = 0;
}

//+-----------------------------------------------------------------------+

void manageAlerts()
{
   if (AlertsOn)
   {
      if (AlertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"UP"); 
         if (trend[whichBar] == -1) doAlert(whichBar,"DOWN");
      }
   }
}

//+-----------------------------------------------------------------------+

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",tf," Signal line : direction changed to ",doWhat);
          if (AlertsMessage) Alert(message);
          if (AlertsEmail)   SendMail(message,message+"\nLocal time "+TimeToStr(TimeLocal(),TIME_SECONDS)+""+"\nBroker time "+TimeToStr(TimeCurrent(),TIME_SECONDS));
          if (AlertsSound)   PlaySound("alert.wav");
   }
}

void Commenter(int Dir) 
{
    if (ShowText)
    {
      ObjectCreate(TextDir,OBJ_LABEL,0,0,0);
      ObjectSet(TextDir,OBJPROP_XDISTANCE,TextPositionX);
      ObjectSet(TextDir,OBJPROP_YDISTANCE,TextPositionY);
      if (Dir == 1) ObjectSetText(TextDir,"BUY",12,"Arial Black", upTextcolor);
      if (Dir ==-1) ObjectSetText(TextDir,"SELL",12,"Arial Black",dnTextcolor);
   }
   
return; 
}